;; Copyright 2008, 2009, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (autoload 'diff-save-buffer "diff-save-buffer" nil t)
  
  (autoload 'diff-save-buffer-keybinding "diff-save-buffer")
  (add-hook 'diff-mode-hook        'diff-save-buffer-keybinding)
  (add-hook 'compilation-mode-hook 'diff-save-buffer-keybinding))

(find-file "/down/emacs/BUGS")

;;-----------------------------------------------------------------------------

(diff "d-diff-save-buffer.el~" "d-diff-save-buffer.el")
(diff-backup "../diff-save-buffer.el")

;;-----------------------------------------------------------------------------
;; vc-diff
;; uses fundamental-mode in emacs20

(progn
  (condition-case nil (require 'diff-mode) (error nil))
  ;; (find-file "/tmp/yoyodyne/rdir/foo")
  (find-file "/down/emacs/etc/spook.lines")
  (call-interactively 'vc-diff))

;;-----------------------------------------------------------------------------

(eq (current-local-map) diff-mode-map)
(eq (current-local-map) compilation-mode-map)


(define-key diff-mode-map [menu-bar mydiff save-buffer]
  '(menu-item "Save" diff-save-buffer
	      :enable (and (buffer-modified-p)
			   (menu-bar-non-minibuffer-window-p))
	      :help "Save current buffer to a .diff file"))

(define-key diff-mode-map [menu-bar mydiff]
  (cons "MyDiff" (make-sparse-keymap "MyDiff Menu")))

(define-key diff-mode-map [menu-bar mydiff diff-save-buffer]
  `(menu-item "Save Diff"
              diff-save-buffer
	      :help "Save current buffer to a .diff file"))

(define-key diff-mode-map [menu-bar file]
  (cons "File" (make-sparse-keymap "My File Menu")))

(define-key diff-mode-map [menu-bar file diff-save-buffer]
  `(menu-item "Save Diff 2"
              diff-save-buffer
	      :help "Save current buffer to a .diff file"))


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))



;;-----------------




(progn
  (autoload 'diff-save-buffer "../diff-save-buffer" nil t)
  (add-hook 'diff-mode-hook
            (lambda ()
              (define-key diff-mode-map [?\C-x ?\C-s] 'diff-save-buffer)))
  (add-hook 'compilation-mode-hook
            (lambda ()
              (define-key compilation-mode-map [?\C-x ?\C-s]
                'diff-save-buffer))))


cvs -d /tmp/mycvsroot init
cd /tmp
mkdir idir
cd idir
echo hello >foo
cvs -d /tmp/mycvsroot import -m "new proj" yoyodyne/rdir yoyo start
cd /tmp
mkdir wdir
cvs -d /tmp/mycvsroot checkout yoyodyne/rdir
