;; Copyright 2009 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(progn
  (add-to-list 'load-path "~/lisp")
  (require 'ffap-makefile-vars))

$HOME/tux
$(HOME)/tux

(setenv "TESTVARS" "/tmp")
$(TESTVARS)$TESTVARS/tux
$TESTVARS$TESTVARS/tux
$$HOME/tux
(substitute-env-vars "$TESTVARS$TESTVARS/tux")

/djfks/$(XYZ)/tux
(expand-file-name "$HOME/tux")
(file-expand-wildcards "$HOME/tux")


(ffap-makefile-vars-substitute-in-filename "$(HOME)")
(ffap-makefile-vars-substitute-in-filename "$(XYZ)-$(HOME)")
(ffap-makefile-vars-substitute-in-filename "$$abc")

XYZ = 123 \
456 $(HOME) 789
(ffap-makefile-vars-find "XYZ")

(compile "cd $HOME/lisp; set -x;
emacs21  -batch -q -no-site-file -f batch-byte-compile ffap-makefile-vars.el;
emacs22  -batch -q -no-site-file -f batch-byte-compile ffap-makefile-vars.el;
xemacs   -batch -q -no-site-file -f batch-byte-compile ffap-makefile-vars.el;
emacs-cvs-b -batch -q -no-site-file -f batch-byte-compile ffap-makefile-vars.el;
rm ffap-makefile-vars.elc")

(progn
  (require 'autoload)
  (switch-to-buffer "x")
  (generate-file-autoloads "~/lisp/ffap-makefile-vars.el"))

(progn
  (switch-to-buffer "x")
  (mapc (lambda (elem)
          (let ((want (car elem))
                (str  (cadr elem)))
            (erase-buffer)
            (insert str)
            (goto-char (point-min))
            (while (not (eobp))
              (let ((got (thing-at-point 'makefile-vars-filename)))
                (or (string-equal want got)
                    (error "Unexpected: %s" got)))
              (forward-char))))
        '(("/etc/passwd"
           "<#part type=\"application/octet-stream\" filename=\"/etc/passwd\" disposition=attachment>\n<#/part>")
          ("/etc/passwd"
           "<#part filename=/etc/passwd>\n<#/part>")
          ("/etc/passwd"
           "<#part filename=/etc/passwd")
          ("/etc/passwd"
           "<#part type=\"application/octet-stream\" filename=\"/tmp/\\\"\" disposition=attachment>\n<#/part>")))
  "ok")
