;; Copyright 2004, 2005, 2009, 2013 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------
(progn
  (add-to-list 'load-path (expand-file-name ".."))
  (require 'gutenberg-coding))

(progn
  (find-file "~/pedia/marlowe/16169-0.txt")
  buffer-file-coding-system)
(progn
  (find-file "~/pedia/horace/8artp10.txt")
  buffer-file-coding-system)

(progn
  (switch-to-buffer "*foo*")
  (erase-buffer)
  (insert-file-contents "~/pedia/marlowe/16169-0.txt" nil 20000 30000)
  buffer-file-coding-system)

(progn
  (mapcar (lambda (filename)
            (find-file (concat "~/guten/samples/" filename))
            (prog1 buffer-file-coding-system
              (kill-buffer (current-buffer))))
          (with-temp-buffer
            (insert-file-contents "~/guten/list.out")
            (delete "" (split-string (buffer-string) "\n"))))
  (switch-to-buffer "*Messages*"))


;; all aus-samples
(progn
  (mapcar (lambda (filename)
            (find-file filename)
            (prog1 buffer-file-coding-system
              (kill-buffer (current-buffer))))
          (directory-files "~/guten/aus-samples/" t "[^.]"))
  (switch-to-buffer "*Messages*"))




;; samples, direct calls
(progn
  (load "../gutenberg-coding.el")
  (mapcar (lambda (filename)
            (find-file-literally filename)
            (when (save-excursion (re-search-forward "[\r\n]Cha[rt]acter [Ss]et" nil t))
              (or (gutenberg-auto-coding-function (- (point-max) (point)))
                  (message "%s: unrecognised" filename)))
            (kill-buffer (current-buffer)))
          (directory-files "~/guten/samples/" t "[^.]"))
  (switch-to-buffer "*Messages*"))


;; aus-samples, direct calls
(progn
  (load "../gutenberg-coding.el")
  (mapcar (lambda (filename)
            (find-file-literally filename)
            (when (save-excursion (re-search-forward "[\r\n]Cha[rt]acter set" nil t))
              (or (gutenberg-auto-coding-function (- (point-max) (point)))
                  (message "%s: unrecognised" filename)))
            (kill-buffer (current-buffer)))
          (directory-files "~/guten/aus-samples/" t "[^.]"))
  (switch-to-buffer "*Messages*"))

;; eu-samples, direct calls
(progn
  (load "../gutenberg-coding.el")
  (mapcar (lambda (filename)
            (find-file-literally filename)
            (when (save-excursion (re-search-forward "[\r\n]Cha[rt]acter set" nil t))
              (or (gutenberg-auto-coding-function (- (point-max) (point)))
                  (message "%s: unrecognised" filename)))
            (kill-buffer (current-buffer)))
          (directory-files "~/guten/eu-samples/" t "[^.]"))
  (switch-to-buffer "*Messages*"))






(defadvice codepage-setup (around my-fake-windows-1252 activate)
  "Pretend windows-1252 exists."
  (if (equal codepage "1252")
      (setq ad-return-value 'latin-1)
    ad-do-it))
