;; Copyright 2007, 2008, 2009, 2012 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


exec-suffixes


(progn
  (add-to-list 'load-path "..")
  (autoload 'perl-pod-preview "perl-pod-preview" nil t)
  (find-file "t-perl-pod-preview.pod")
  (perl-pod-preview))

(progn
  (add-to-list 'load-path "..")
  (autoload 'perl-pod-preview "perl-pod-preview" nil t)
  (find-file "/usr/share/perl5/Jcode/Nihongo.pod")
  (perl-pod-preview))

(progn
  (add-to-list 'load-path "..")
  (autoload 'perl-pod-preview "perl-pod-preview" nil t)
  (switch-to-buffer "foo")
  (insert-file-contents "d-perl-pod-preview.pod")
  (setq default-directory "/no/such/dir/")
  (perl-pod-preview))


;;-----------------

(let ((tempfile "/tmp/x.el")
      (print-level nil))
  (require 'autoload)
  (find-file tempfile)
  (erase-buffer)
  (generate-file-autoloads "../perl-pod-preview.el")
  (save-buffer)
  (byte-compile-file tempfile)
  (delete-file (concat tempfile "c"))
  (delete-file tempfile))


;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))


;;-----------------------------------------------------------------------------
;; autorevert

(progn
  (with-current-buffer "*perl-pod-preview*"
    (auto-revert-mode 1))
  (setq auto-revert-interval 2)
  (auto-revert-set-timer))


;;-----------------------------------------------------------------------------
;; emacs21

(require 'pod-mode)
(require 'perl-pod-gt)

(progn
  (load "~/lisp/perl-pod-preview.el")
  (find-file "d-perl-pod-preview.pod")
  (when (fboundp 'perl-pod-preview)
    (define-key global-map [f8] 'perl-pod-preview)
    (eval-after-load "cperl-mode"
      '(define-key cperl-mode-map [f8] 'perl-pod-preview))
    (eval-after-load "perl-mode"
      '(define-key perl-mode-map [f8] 'perl-pod-preview))
    (eval-after-load "pod-mode"
      '(define-key pod-mode-map [f8] 'perl-pod-preview)))
  )


;;-----------------------------------------------------------------------------
;; woman

(setq perl-pod-preview-have-man-p 'no)




