;; Copyright 2014, 2016 Kevin Ryde.

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.


(progn
  (require 'renice)
  (compile "sleep 99")
  (switch-to-buffer "*compilation*"))
Compilation-mode-popup-menu
(add-menu-item

;;-----------------
;; compile

(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-byte-compile))
(progn
  (add-to-list 'load-path (expand-file-name "."))
  (require 'my-byte-compile)
  (my-show-autoloads))

;;-----------------------------------------------------------------------------
;; read-number

(read-number "niceness: " 19)                  ;; emacs
(read-number "niceness (default 19): " t "19") ;; xemacs

(string-to-number (read-string "niceness (default 19): "
                               nil
                               'renice-nice-history
                               "19"))

;;-----------------------------------------------------------------------------

(define-key  "R" 'renice)

;; (process-attributes 1)
;; (eq 'real (process-type (current-buffer)))
(let ((process (start-process "sleeper" "*scratch*" "sleep" "600")
               ;; (start-process "echo" "*scratch*" "echo" "hi")
               ))
  (sit-for 1)
  (process-id process)
  (process-live-p process)
  (process-name process)

  (let ((pid (process-id process)))
    (pp pid (current-buffer))
    (insert "\n")
    (pp (process-attributes pid) (current-buffer))
    (insert "\n")))


;;-----------------------------------------------------------------------------
(defun renice--process-real-p (process)
  "Return non-nil if PROCESS is a real sub-process.
This is an internal part of renice.el.

PROCESS is real if `process-type' is `real', or if there's no
`process-type' function at all as Emacs prior to version 23 where
all process objects are real sub-process."

  (or (eval-when-compile (not (fboundp 'process-type)))
      (eq 'real (process-type process))))

