;; Copyright 2009, 2010, 2011 Kevin Ryde

;; This file is part of miscbits-el.
;;
;; miscbits-el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; miscbits-el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You should have received a copy of the GNU General Public License along
;; with miscbits-el; see the file COPYING.  Failing that, go to
;; <http://www.gnu.org/licenses/>.

(add-to-list 'load-path (expand-file-name ".."))

(defun my-run-test ()
  (require 'miscbits-el-loaddefs)
  (let ((count 0))

    ;; check the autoload cookie eval-after-load
    (require 'compile)
    (or (featurep 'compilation-ledger)
        (error "compilation-ledger.el not loaded after compile.el"))
    (setq count (1+ count))


    (add-to-list 'load-path (expand-file-name "."))
    (require 'my-compile-testing)

    (my-compilation-validate-alists)

    (find-file "t-compilation-ledger.txt")
    (compilation-mode)
    (let ((got  (my-compilation-error-lines))
          (want '((26 "foo.ledger" 1656))))
      (or (equal got want)
          (error "wrong error lines: got %s want %s" got want)))
    (setq count (1+ count))
    (kill-buffer nil)

    ;;-------------------------------------------------------------------------
    ;; unload-feature

    (add-to-list 'load-path (expand-file-name "."))
    (require 'my-unload)

    (if (not my-unload-feature-function-p)
        (message "skip, no unload-feature function")

      (let ((feature 'compilation-ledger))

        (unload-feature feature t)

        (when (memq 'compilation-ledger compilation-error-regexp-alist)
          (error "still in compilation-error-regexp-alist"))
        (when (assq 'compilation-ledger
                    compilation-error-regexp-alist-alist)
          (error "still in compilation-error-regexp-alist-alist"))
        (setq count (1+ count))))


    ;; couple of cycles
    (require 'compilation-ledger)
    (unload-feature 'compilation-ledger t)
    (require 'compilation-ledger)
    (unload-feature 'compilation-ledger t)
    (setq count (1+ count))


    ;;-------------------------------------------------------------------------
    (message "  %d tests" count)
    count))
