;; Copyright 2011, 2015 Kevin Ryde
;;
;; html-sizes.el is free software; you can redistribute it and/or modify it
;; under the terms of the GNU General Public License as published by the
;; Free Software Foundation; either version 3, or (at your option) any later
;; version.
;;
;; html-sizes.el is distributed in the hope that it will be useful, but
;; WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
;; Public License for more details.
;;
;; You can get a copy of the GNU General Public License online at
;; <http://www.gnu.org/licenses/>.


;; This was an idea to make calendar holidays for New Year, Easter, etc
;; where if they fall on a weekend the public holiday is the next weekday.
;;
;; Didn't really work.



;;-----------------------------------------------------------------------------
;; calendar - holidays

(defun holidays-australia-date-add (date n)
  (calendar-gregorian-from-absolute
   (+ n (calendar-absolute-from-gregorian date))))

(defun my-holiday-easter (n string)
  "Return a holiday date N days before or after Easter, with name STRING.
This function is designed for use in `general-holidays' and friends.  For
example,

    (setq general-holidays
          ((my-holiday-easter 1 \"Easter Monday\")))"

  (let* ((all-christian-calendar-holidays nil)
         (date (car (rassoc '("Easter Sunday") (holiday-easter-etc)))))
    (list (my-calendar-date-add n date) string)))

(defun my-holiday-fixed-next-weekday (month day string)
  (let ((elem (holiday-fixed month day string)))
    (and elem
         (let ((date (car elem))
               (wday (calendar-day-of-week date)))
           (cond ((= 0 wday)
                  (list (holidays-australia-date-add date 1) string))
                 ((= 6 wday)
                  (list (holidays-australia-date-add date 2) string))
                 (t
                  elem))))))

'
(let ((displayed-month 4)
      (displayed-year 2006))
  '(my-holiday-easter 0 "sun")
  '(my-holiday-fixed-next-weekday 1 1 "newy")
  '(holiday-fixed 1 1 "newy")
  '(holidays-australia-transfer
    (holiday-fixed 4 25 "Anzac Day"))
  '(holidays-australia-transfer
    (append (holiday-fixed 12 25 "Christmas Day")
           (holiday-fixed 12 26 "Boxing Day")))
  (holiday-easter-etc))

(defun pk (x)
  (message "pk: %s" x)
  x)

(defun holidays-australia-transfer (lst)
  (mapc (lambda (elem)
          (let* ((date (first elem))
                 (dow  (calendar-day-of-week date)))
            (when (memq (calendar-day-of-week date) '(0 6))
              (while (progn
                       (setq date (holidays-australia-date-add date 1))
                       (or (memq (calendar-day-of-week date) '(0 6))
                           (assoc date lst))))
              (setq lst (cons (list date
                                    (concat (cadr elem) " - transferred"))
                              lst)))))
        lst)
  lst)
            
(setq general-holidays
      '(
        (holidays-australia-transfer
         (holiday-fixed 1 1 "New Year's Day"))
        (holidays-australia-transfer
         (holiday-fixed 1 26 "Australia Day"))
        ;;     (my-holiday-easter -2 "Good Friday")
        ;;     (my-holiday-easter 0 "Easter Sunday")
        ;;     (my-holiday-easter 1 "Easter Monday")
        (holidays-australia-transfer
         (holiday-fixed 4 25 "Anzac Day"))
        (holiday-float 6 1 2 "Queen's Birthday") ;; 2nd Monday in June
        (holiday-fixed 10 1 "Labour Day")
        (holidays-australia-transfer
         (append (holiday-fixed 12 25 "Christmas Day")
                 (holiday-fixed 12 26 "Boxing Day")))
        ))

(setq christian-holidays nil)
(setq hebrew-holidays nil)
(setq islamic-holidays nil)


